SystemOrganization addCategory: #BackgammonController!

SimpleButtonMorph subclass: #InputButton
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!InputButton commentStamp: 'jChizmar 7/9/2015 07:56' prior: 0!
A button that responds to input!

!InputButton class methodsFor: 'initialize' stamp: 'DavidOvergaard 7/16/2015 21:14'!
text:labelText
	"comment stating purpose of message"
	super initialize.
^ ((self new) 	labelString: 'Push Me'; 
					minWidth: 100; 
					extent:100@100;
					left:200;
					top: 50
					"color: (Color r: 255.0 g: 255.0 b: 255.0)" ).! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:50'!
mouseAction: t1
	^ mouseAction := t1! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:54'!
mouseUp: t1
	mouseAction value.
	^ self! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:54'!
toggleChecker: aChecker onBoard: myBoardModel
	| myMoveCommand prevLocation |
	
	prevLocation := ((aChecker checkerLocation) pointNumber).
	
	prevLocation = 2
	ifTrue: [ 
		myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:12).	
		 ]
	ifFalse: [ 
		myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:2 ).	
		 ].
	
	myMoveCommand execute.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:32'!
toggleLocation
	| aChecker myBoardModel myMoveCommand |
	
	myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:12).
	myMoveCommand execute.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/10/2015 20:50'!
toggleText
"toggle the text on the button"
	(self label = 'Push Me')
	ifTrue:[
		self labelString: 'Pushed'
		]
	ifFalse:[
		self labelString: 'Push Me'
		]! !

Object subclass: #BackgammonStart
	instanceVariableNames: 'myBoardModel myBoardView observables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!BackgammonStart commentStamp: 'DavidOvergaard 7/16/2015 21:27' prior: 0!
Initialize and run backgammon game!

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:27'!
start
	^BackgammonStart new start.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:01'!
model
	^myBoardModel.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:53'!
notify: aChecker
	myBoardView moveCheckerNum: 1 toPoint: (aChecker checkerLocation) pointNumber.
	
Transcript show: (aChecker checkerLocation) pointNumber.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:23'!
observable: anObject
	observables add: anObject.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:16'!
observables
	^observables! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:39'!
start
	| button1 |
	myBoardModel := MainBoard initialize.
	myBoardView := BackgammonBoard createNewBoard.
	observables := OrderedCollection new.

	(myBoardModel player1Checkers) do: [ :aChecker |
		myBoardView addCheckerAtPoint: ((aChecker checkerLocation) pointNumber) color: (aChecker color).
		aChecker addObserver: self.
		 ].
	
	(myBoardModel player2Checkers) do: [ :aChecker |
		myBoardView addCheckerAtPoint: ((aChecker checkerLocation) pointNumber) color: (aChecker color).
		 ].
	
	"Test move with observer"
 	button1 := InputButton text: 'Toggle player 1 checker location'. 
	button1 mouseAction: [button1 toggleChecker: ((myBoardModel player1Checkers) at: 1) onBoard: myBoardModel].
	myBoardView addMorph: button1.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:02'!
view
	^myBoardView := BackgammonBoard createNewBoard.! !
